﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace $safeprojectname$
{
	/// <summary>
	/// Informationen zum Projektordner
	/// </summary>
	internal static class AssemblySourceInfo
	{
		/// <summary>
		/// DefaultNamespace des Projekts
		/// </summary>
		internal const String DefaultNamespace = "$safeprojectname$";

		/// <summary>
		/// Der Verzeichnisname für die Quelltexte der Lib.
		/// </summary>
		internal static String SourceCodeBaseFolder
		{
			get
			{
				if (null == __ASSEMBLY_PATH)
				{
					try
					{
						__ASSEMBLY_PATH = GetMyPath();
					}
					catch (Exception ex)
					{
						throw new Exception("Der ASSEMBLY_PATH konnte nicht bestimmt werden. Dieser wird für Debug-Informationen benötigt. Der Fehler lautet:" + ex.Message + " " + ex.StackTrace, ex);
					}
				}
				return __ASSEMBLY_PATH;
			}
		}
		/// <summary>
		/// Für Layouts der Eigenschaften
		/// </summary>
		/// <param name="typeName"></param>
		/// <returns></returns>
		public static IduIT.Core.PropertyModel.Auto.LayoutType GetPropertyModelLayout(string typeName)
		{
			return Core.PropertyModel.PMXmlLayoutLoader.GetLayoutFromResource(
					DefaultNamespace,
					SourceCodeBaseFolder,
					typeof(AssemblySourceInfo).Assembly,
					typeName,
#if DEBUG
				true
#else
		        false
#endif
			);
		}


		private static String GetMyPath([System.Runtime.CompilerServices.CallerFilePath]
			String dir = null)
		{
			return System.IO.Path.GetDirectoryName(dir);
		}

		private static String __ASSEMBLY_PATH;
	}
}
